// Code generated by client-gen. DO NOT EDIT.

package v1alpha2

import (
	"context"
	"time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
	v1alpha2 "px.dev/pixie/src/operator/apis/nats.io/v1alpha2"
	scheme "px.dev/pixie/src/operator/vendored/nats/scheme"
)

// NatsClustersGetter has a method to return a NatsClusterInterface.
// A group's client should implement this interface.
type NatsClustersGetter interface {
	NatsClusters(namespace string) NatsClusterInterface
}

// NatsClusterInterface has methods to work with NatsCluster resources.
type NatsClusterInterface interface {
	Create(ctx context.Context, natsCluster *v1alpha2.NatsCluster, opts v1.CreateOptions) (*v1alpha2.NatsCluster, error)
	Update(ctx context.Context, natsCluster *v1alpha2.NatsCluster, opts v1.UpdateOptions) (*v1alpha2.NatsCluster, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha2.NatsCluster, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha2.NatsClusterList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha2.NatsCluster, err error)
	NatsClusterExpansion
}

// natsClusters implements NatsClusterInterface
type natsClusters struct {
	client rest.Interface
	ns     string
}

// newNatsClusters returns a NatsClusters
func newNatsClusters(c *NatsV1alpha2Client, namespace string) *natsClusters {
	return &natsClusters{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the natsCluster, and returns the corresponding natsCluster object, and an error if there is any.
func (c *natsClusters) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha2.NatsCluster, err error) {
	result = &v1alpha2.NatsCluster{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("natsclusters").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of NatsClusters that match those selectors.
func (c *natsClusters) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha2.NatsClusterList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha2.NatsClusterList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("natsclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested natsClusters.
func (c *natsClusters) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("natsclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a natsCluster and creates it.  Returns the server's representation of the natsCluster, and an error, if there is any.
func (c *natsClusters) Create(ctx context.Context, natsCluster *v1alpha2.NatsCluster, opts v1.CreateOptions) (result *v1alpha2.NatsCluster, err error) {
	result = &v1alpha2.NatsCluster{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("natsclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(natsCluster).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a natsCluster and updates it. Returns the server's representation of the natsCluster, and an error, if there is any.
func (c *natsClusters) Update(ctx context.Context, natsCluster *v1alpha2.NatsCluster, opts v1.UpdateOptions) (result *v1alpha2.NatsCluster, err error) {
	result = &v1alpha2.NatsCluster{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("natsclusters").
		Name(natsCluster.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(natsCluster).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the natsCluster and deletes it. Returns an error if one occurs.
func (c *natsClusters) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("natsclusters").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *natsClusters) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("natsclusters").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched natsCluster.
func (c *natsClusters) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha2.NatsCluster, err error) {
	result = &v1alpha2.NatsCluster{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("natsclusters").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
